#ifndef __NDS_ITERATE_STATE_H__
#define __NDS_ITERATE_STATE_H__

namespace NDS
{

  class iterate_state
  {
  public:
  	iterate_state(buffer::gps_second_type gps_start, buffer::gps_second_type gps_stop, buffer::gps_second_type stride, const channel::channel_names_type& channel_names): \
  		fragment_list(), cur_segment(0), cur_gps(0), gps_start(gps_start), gps_stop(gps_stop), max_stride(stride), names(channel_names) \
  		{};
  	request_fragments_type fragment_list;
  	buffer::size_type cur_segment;
  	buffer::gps_second_type cur_gps;
  	buffer::gps_second_type gps_start;
  	buffer::gps_second_type gps_stop;
  	buffer::gps_second_type max_stride;
  	channel::channel_names_type names;
    buffers_type_intl next_entry;
  };

  class iterate_full_state
  {
  public:
    iterate_full_state(buffer::gps_second_type gps_start, buffer::gps_second_type gps_stop, buffer::gps_second_type stride, const channel::channel_names_type& channel_names, epoch prev_epoch, const channels_type_intl &channel_list): \
     gps_start(gps_start), gps_stop(gps_stop), gps_stride(stride), cur_gps(gps_start), names(channel_names), \
     prev_epoch(prev_epoch), channels(channel_list) {};

    buffer::gps_second_type gps_start;
    buffer::gps_second_type gps_stop;
    buffer::gps_second_type gps_stride;
    buffer::gps_second_type cur_gps;
    channel::channel_names_type names;
	channels_type_intl channels;
    epoch prev_epoch;

    void advance() { cur_gps += gps_stride; };
    bool done() const { return (gps_stride == 0 || cur_gps >= gps_stop); };
  };
}


#endif // __NDS_ITERATE_STATE_H__
